const DefinePlugin = require('webpack/lib/DefinePlugin')
const {DEVELOPMENT, PRODUCTION, STAGING} = require('./environment')

module.exports = function(ENV, packageDir, userConstants) {
  constants = {
    ...userConstants,
    ENV,
    DEVELOPMENT,
    STAGING,
    PRODUCTION,
    'process.env.NODE_ENV': ENV === DEVELOPMENT ? 'development' : 'production',
    'VERSION': require(`${packageDir}/package.json`).version,
  }

  outConstants = {}
  for (const i in constants) {
    outConstants[i] = JSON.stringify(constants[i])
  }

  return new DefinePlugin(outConstants)
}

