const path = require('path')
const fs = require('fs')

/**
 *
 */
module.exports = createEntryMap

/**
 *
 */
function createEntryMap(webpackRootDir, entryDirName = 'entries') {
  const entryDir = path.join(webpackRootDir, entryDirName)
  if (!fs.existsSync(entryDir)) {
    throw 'Webpack entries directory DNE.'
  }

  const entryMap = {}
  for (const entry of getNamesFromDirectory(entryDir)) {
    entryMap[`entries/${entry}`] = `./${entryDirName}/${entry}`
  }
  return entryMap
}

/**
 *
 */
function getNamesFromDirectory(filepath) {
  return fs
    .readdirSync(filepath)
    .filter(filename => filename[0] !== '#')
    .map(filename => {
      let entryName, ext
      if (fs.lstatSync(`${filepath}/${filename}`).isDirectory()) {
        entryName = filename
      } else {
        ext = path.extname(filename)
        entryName = filename.substr(0, filename.length - ext.length)
      }
      return entryName
    })
}